diff --git a/src/main/java/net/minecraft/core/entity/EntityDispatcher.java b/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
index a8044bf50..f50e6a645 100644
--- a/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
+++ b/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
@@ -3,23 +3,14 @@ package net.minecraft.core.entity;
 import net.minecraft.core.entity.animal.*;
 import net.minecraft.core.entity.monster.*;
 import net.minecraft.core.entity.projectile.*;
-import net.minecraft.core.entity.vehicle.EntityBoat;
-import net.minecraft.core.entity.vehicle.EntityMinecart;
+import net.minecraft.core.entity.vehicle.BoatEntity;
+import net.minecraft.core.entity.vehicle.MinecartEntity;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.world.World;
 
 import java.util.HashMap;
 import java.util.Map;
 
-// Referenced classes of package net.minecraft.src:
-//            World, Entity, NBTTagCompound, EntityArrow, 
-//            EntitySnowball, EntityItem, EntityPainting, EntityLiving, 
-//            EntityMob, EntityCreeper, EntitySkeleton, EntitySpider, 
-//            EntityGiantZombie, EntityZombie, EntitySlime, EntityGhast, 
-//            EntityPigZombie, EntityPig, EntitySheep, EntityCow, 
-//            EntityChicken, EntitySquid, EntityWolf, EntityTNTPrimed, 
-//            EntityFallingSand, EntityMinecart, EntityBoat
-
 public class EntityDispatcher
 {
 
@@ -40,10 +31,10 @@ public class EntityDispatcher
         Entity entity = null;
         try
         {
-            Class<? extends Entity> entityClass = keyToClassMap.get(s);
-            if(entityClass != null)
+            Class<? extends Entity> clazz = keyToClassMap.get(s);
+            if(clazz != null)
             {
-                entity = entityClass.getConstructor(World.class).newInstance(world);
+                entity = clazz.getConstructor(World.class).newInstance(world);
             }
         }
         catch(Exception exception)
@@ -54,19 +45,15 @@ public class EntityDispatcher
         return entity;
     }
 
-    public static Entity createEntityFromNBT(CompoundTag nbttagcompound, World world)
+    public static Entity createEntityFromNBT(CompoundTag compoundTag, World world)
     {
         Entity entity = null;
         try
         {
-            Class class1 = (Class) keyToClassMap.get(nbttagcompound.getString("id"));
-            if(class1 != null)
+            Class<? extends Entity> clazz = keyToClassMap.get(compoundTag.getString("id"));
+            if(clazz != null)
             {
-                entity = (Entity)class1.getConstructor(new Class[] {
-                    World.class
-                }).newInstance(new Object[] {
-                    world
-                });
+                entity = clazz.getConstructor(new Class[] {World.class}).newInstance(world);
             }
         }
         catch(Exception exception)
@@ -75,27 +62,22 @@ public class EntityDispatcher
         }
         if(entity != null)
         {
-            entity.load(nbttagcompound);
+            entity.load(compoundTag);
         } else
         {
-            System.out.println((new StringBuilder()).append("Skipping Entity with id ").append(nbttagcompound.getString("id")).toString());
+            System.out.println("Skipping Entity with id " + compoundTag.getString("id"));
         }
         return entity;
     }
 
-    public static Entity createEntity(int i, World world)
+    public static Entity createEntity(int id, World world)
     {
         Entity entity = null;
         try
         {
-            Class class1 = (Class) idToClassMap.get(Integer.valueOf(i));
-            if(class1 != null)
-            {
-                entity = (Entity)class1.getConstructor(new Class[] {
-                    World.class
-                }).newInstance(new Object[] {
-                    world
-                });
+            Class<? extends Entity> clazz = idToClassMap.get(id);
+            if(clazz != null) {
+                entity = clazz.getConstructor(new Class[] {World.class}).newInstance(world);
             }
         }
         catch(Exception exception)
@@ -104,7 +86,7 @@ public class EntityDispatcher
         }
         if(entity == null)
         {
-            System.out.println((new StringBuilder()).append("Skipping Entity with id ").append(i).toString());
+            System.out.println("Skipping Entity with id " + id);
         }
         return entity;
     }
@@ -118,11 +100,24 @@ public class EntityDispatcher
         return classToIdMap.get(entityClass);
     }
 
-    public static String getEntityString(Entity entity)
+    public static String getEncodeId(Entity entity)
     {
         return classToKeyMap.get(entity.getClass());
     }
 
+    public static String getEncodeId(Class<? extends Entity> clazz)
+    {
+        return classToKeyMap.get(clazz);
+    }
+
+    public static Class<? extends Entity> getClassFromID(int id) {
+        return idToClassMap.get(id);
+    }
+
+    public static Class<? extends Entity> getClassFromEncodeID(String encodeID) {
+        return keyToClassMap.get(encodeID);
+    }
+
     public static final Map<String, Class<? extends Entity>> keyToClassMap = new HashMap<>();
     public static final Map<Class<? extends Entity>, String> classToKeyMap = new HashMap<>();
     private static final Map<Integer, Class<? extends Entity>> idToClassMap = new HashMap<>();
@@ -130,39 +125,39 @@ public class EntityDispatcher
 
     static 
     {
-        addMapping(EntityItem.class, "Item", 1);
-        addMapping(EntityLightningBolt.class, "Lightning", 8);
-        addMapping(EntityPainting.class, "Painting", 9);
-        addMapping(EntityArrow.class, "Arrow", 10);
-        addMapping(EntitySnowball.class, "Snowball", 11);
-        addMapping(EntityFireball.class, "Fireball", 12);
-        addMapping(EntityTNT.class, "PrimedTnt", 20);
-        addMapping(EntityFallingSand.class, "FallingSand", 21);
-        addMapping(EntityMinecart.class, "Minecart", 40);
-        addMapping(EntityBoat.class, "Boat", 41);
-        addMapping(EntityArmoredZombie.class, "ArmouredZombie", 42);
-        addMapping(EntityArrowGolden.class, "ArrowGolden", 43);
-        addMapping(EntityCannonball.class, "Cannonball", 44);
-        addMapping(EntityArrowPurple.class, "ArrowPurple", 45);
-        addMapping(EntityPebble.class, "Pebble", 46);
-        addMapping(EntityFireflyCluster.class, "FireflyCluster", 47);
-        addMapping(EntityLiving.class, "Mob", 48);
-        addMapping(EntityHuman.class, "Monster", 49);
-        addMapping(EntityCreeper.class, "Creeper", 50);
-        addMapping(EntitySkeleton.class, "Skeleton", 51);
-        addMapping(EntitySpider.class, "Spider", 52);
-        addMapping(EntityGiant.class, "Giant", 53);
-        addMapping(EntityZombie.class, "Zombie", 54);
-        addMapping(EntitySlime.class, "Slime", 55);
-        addMapping(EntityGhast.class, "Ghast", 56);
-        addMapping(EntityPigZombie.class, "PigZombie", 57);
-        addMapping(EntitySnowman.class, "Snowman", 58);
-        addMapping(EntityScorpion.class, "Scorpion", 59);
-        addMapping(EntityPig.class, "Pig", 90);
-        addMapping(EntitySheep.class, "Sheep", 91);
-        addMapping(EntityCow.class, "Cow", 92);
-        addMapping(EntityChicken.class, "Chicken", 93);
-        addMapping(EntitySquid.class, "Squid", 94);
-        addMapping(EntityWolf.class, "Wolf", 95);
+        addMapping(ItemEntity.class, "Item", 1);
+        addMapping(LightningEntity.class, "Lightning", 8);
+        addMapping(PaintingEntity.class, "Painting", 9);
+        addMapping(ArrowProjectile.class, "Arrow", 10);
+        addMapping(SnowballProjectile.class, "Snowball", 11);
+        addMapping(FireballProjectile.class, "Fireball", 12);
+        addMapping(TNTPrimedEntity.class, "PrimedTnt", 20);
+        addMapping(FallingBlockEntity.class, "FallingSand", 21);
+        addMapping(MinecartEntity.class, "Minecart", 40);
+        addMapping(BoatEntity.class, "Boat", 41);
+        addMapping(ZombieArmoredMob.class, "ArmouredZombie", 42);
+        addMapping(ArrowProjectileGolden.class, "ArrowGolden", 43);
+        addMapping(CannonballProjectile.class, "Cannonball", 44);
+        addMapping(ArrowProjectilePurple.class, "ArrowPurple", 45);
+        addMapping(PebbleProjectile.class, "Pebble", 46);
+        addMapping(FireflyClusterMob.class, "FireflyCluster", 47);
+        addMapping(Mob.class, "Mob", 48);
+        addMapping(HumanMob.class, "Monster", 49);
+        addMapping(CreeperMob.class, "Creeper", 50);
+        addMapping(SkeletonMob.class, "Skeleton", 51);
+        addMapping(SpiderMob.class, "Spider", 52);
+        addMapping(GiantMob.class, "Giant", 53);
+        addMapping(ZombieMob.class, "Zombie", 54);
+        addMapping(SlimeMob.class, "Slime", 55);
+        addMapping(GhastMob.class, "Ghast", 56);
+        addMapping(ZombiePigMob.class, "PigZombie", 57);
+        addMapping(SnowmanMob.class, "Snowman", 58);
+        addMapping(ScorpionMob.class, "Scorpion", 59);
+        addMapping(PigMob.class, "Pig", 90);
+        addMapping(SheepMob.class, "Sheep", 91);
+        addMapping(CowMob.class, "Cow", 92);
+        addMapping(ChickenMob.class, "Chicken", 93);
+        addMapping(SquidMob.class, "Squid", 94);
+        addMapping(WolfMob.class, "Wolf", 95);
     }
 }
diff --git a/src/main/java/net/minecraft/core/entity/EntityFallingSand.java b/src/main/java/net/minecraft/core/entity/FallingBlockEntity.java
similarity index 77%
rename from src/main/java/net/minecraft/core/entity/EntityFallingSand.java
rename to src/main/java/net/minecraft/core/entity/FallingBlockEntity.java
index a139d371c..17b38abac 100644
--- a/src/main/java/net/minecraft/core/entity/EntityFallingSand.java
+++ b/src/main/java/net/minecraft/core/entity/FallingBlockEntity.java
@@ -2,42 +2,43 @@ package net.minecraft.core.entity;
 
 
 // Referenced classes of package net.minecraft.src:
-//            Entity, MathHelper, World, BlockSand, 
+//            Entity, MathHelper, World, SandBlock,
 //            NBTTagCompound
 
-import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockSand;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.SandBlock;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.world.World;
 
-public class EntityFallingSand extends Entity
+public class FallingBlockEntity extends Entity
 {
+    public int blockID;
+    public int fallTime;
+    public boolean hasRemovedBlock = false;
 
-    public EntityFallingSand(World world)
+    public FallingBlockEntity(World world)
     {
         super(world);
-        blockID = Block.sand.id;
+        blockID = Blocks.SAND.id;
         fallTime = 0;
     }
 
-    public EntityFallingSand(World world, double d, double d1, double d2, 
-            int i)
-    {
+    public FallingBlockEntity(World world, double x, double y, double z, int blockId) {
         super(world);
         fallTime = 0;
-        blockID = i;
+        blockID = blockId;
         blocksBuilding = true;
         setSize(0.98F, 0.98F);
         heightOffset = bbHeight / 2.0F;
-        setPos(d, d1, d2);
+        setPos(x, y, z);
         xd = 0.0D;
         yd = 0.0D;
         zd = 0.0D;
-        xo = d;
-        yo = d1;
-        zo = d2;
+        xo = x;
+        yo = y;
+        zo = z;
     }
 
     @Override
@@ -47,7 +48,7 @@ public class EntityFallingSand extends Entity
     }
 
     @Override
-	protected void init()
+	protected void defineSynchedData()
     {
     }
 
@@ -74,9 +75,9 @@ public class EntityFallingSand extends Entity
         xd *= 0.98D;
         yd *= 0.98D;
         zd *= 0.98D;
-        int i = MathHelper.floor_double(x);
-        int j = MathHelper.floor_double(y);
-        int k = MathHelper.floor_double(z);
+        int i = MathHelper.floor(x);
+        int j = MathHelper.floor(y);
+        int k = MathHelper.floor(z);
         if(world.getBlockId(i, j, k) == blockID)
         {
             world.setBlockWithNotify(i, j, k, 0);
@@ -88,7 +89,7 @@ public class EntityFallingSand extends Entity
             zd *= 0.7D;
             yd *= -0.5D;
             remove();
-            if((!world.canBlockBePlacedAt(blockID, i, j, k, true, Side.TOP) || BlockSand.canFallBelow(world, i, j - 1, k) || !world.setBlockWithNotify(i, j, k, blockID)) && !world.isClientSide)
+            if((!world.canBlockBePlacedAt(blockID, i, j, k, true, Side.TOP) || SandBlock.canFallBelow(world, i, j - 1, k) || !world.setBlockWithNotify(i, j, k, blockID)) && !world.isClientSide)
             {
             	if(hasRemovedBlock) {
             		spawnAtLocation(blockID, 1);
@@ -131,8 +132,4 @@ public class EntityFallingSand extends Entity
     public boolean showBoundingBoxOnHover() {
         return true;
     }
-
-    public int blockID;
-    public int fallTime;
-    public boolean hasRemovedBlock = false;
 }
diff --git a/src/main/java/net/minecraft/core/entity/EntityBobber.java b/src/main/java/net/minecraft/core/entity/FishingBobberEntity.java
similarity index 60%
rename from src/main/java/net/minecraft/core/entity/EntityBobber.java
rename to src/main/java/net/minecraft/core/entity/FishingBobberEntity.java
index 98a846379..34afa481a 100644
--- a/src/main/java/net/minecraft/core/entity/EntityBobber.java
+++ b/src/main/java/net/minecraft/core/entity/FishingBobberEntity.java
@@ -1,42 +1,42 @@
 package net.minecraft.core.entity;
 
-import net.minecraft.core.HitResult;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.util.phys.HitResult;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.achievement.stat.StatList;
-import net.minecraft.core.entity.player.EntityPlayer;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.MathHelper;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.world.World;
-import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.helper.DamageType;
 
 import java.util.List;
 
-public class EntityBobber extends Entity
+public class FishingBobberEntity extends Entity
 {
     private int xTile;
     private int yTile;
     private int zTile;
     private boolean inGround;
-    public EntityPlayer player;
+    public Player owner;
     private int ticksInAir;
     private int ticksCatchable;
     public Entity hookedEntity;
-    private int field_6388_l;
-    private double field_6387_m;
-    private double field_6386_n;
-    private double field_6385_o;
-    private double field_6384_p;
-    private double field_6383_q;
+    private int lerpSteps;
+    private double lerpX;
+    private double lerpY;
+    private double lerpZ;
+    private double lerpYRot;
+    private double lerpXRot;
     private double velocityX;
     private double velocityY;
     private double velocityZ;
 
-    public EntityBobber(World world)
+    public FishingBobberEntity(World world)
     {
         super(world);
         ticksInAir = 0;
@@ -46,24 +46,24 @@ public class EntityBobber extends Entity
         ignoreFrustumCheck = true;
     }
 
-    public EntityBobber(World world, double d, double d1, double d2)
+    public FishingBobberEntity(World world, double x, double y, double z)
     {
         this(world);
-        setPos(d, d1, d2);
+        setPos(x, y, z);
         ignoreFrustumCheck = true;
     }
 
-    public EntityBobber(World world, EntityPlayer entityplayer)
+    public FishingBobberEntity(World world, Player owner)
     {
         super(world);
         ticksInAir = 0;
         ticksCatchable = 0;
         hookedEntity = null;
         ignoreFrustumCheck = true;
-        player = entityplayer;
-        player.bobberEntity = this;
+        this.owner = owner;
+        this.owner.bobberEntity = this;
         setSize(0.25F, 0.25F);
-        moveTo(entityplayer.x, (entityplayer.y + 1.62D) - (double)entityplayer.heightOffset, entityplayer.z, entityplayer.yRot, entityplayer.xRot);
+        moveTo(owner.x, (owner.y + 1.62D) - (double)owner.heightOffset, owner.z, owner.yRot, owner.xRot);
         x -= MathHelper.cos((yRot / 180F) * MathHelper.PI) * 0.16F;
         y -= 0.1D;
         z -= MathHelper.sin((yRot / 180F) * MathHelper.PI) * 0.16F;
@@ -73,53 +73,51 @@ public class EntityBobber extends Entity
         xd = -MathHelper.sin((yRot / 180F) * MathHelper.PI) * MathHelper.cos((xRot / 180F) * MathHelper.PI) * f;
         zd = MathHelper.cos((yRot / 180F) * MathHelper.PI) * MathHelper.cos((xRot / 180F) * MathHelper.PI) * f;
         yd = -MathHelper.sin((xRot / 180F) * MathHelper.PI) * f;
-        func_4042_a(xd, yd, zd, 1.5F, 1.0F);
+        shoot(xd, yd, zd, 1.5F, 1.0F);
     }
 
     @Override
-	protected void init()
+	protected void defineSynchedData()
     {
     }
 
     @Override
 	public boolean shouldRenderAtSqrDistance(double distance)
     {
-        double d1 = bb.getAverageEdgeLength() * 4D;
+        double d1 = bb.getSize() * 4D;
         d1 *= 64D;
         return distance < d1 * d1;
     }
 
-    public void func_4042_a(double d, double d1, double d2, float f, 
-            float f1)
-    {
-        float f2 = MathHelper.sqrt_double(d * d + d1 * d1 + d2 * d2);
-        d /= f2;
-        d1 /= f2;
-        d2 /= f2;
-        d += random.nextGaussian() * 0.0075D * (double)f1;
-        d1 += random.nextGaussian() * 0.0075D * (double)f1;
-        d2 += random.nextGaussian() * 0.0075D * (double)f1;
-        d *= f;
-        d1 *= f;
-        d2 *= f;
-        xd = d;
-        yd = d1;
-        zd = d2;
-        float f3 = MathHelper.sqrt_double(d * d + d2 * d2);
-        yRotO = yRot = (float)((Math.atan2(d, d2) * 180D) / Math.PI);
-        xRotO = xRot = (float)((Math.atan2(d1, f3) * 180D) / Math.PI);
+    public void shoot(double x, double y, double z, float speed, float randomness) {
+        float f2 = MathHelper.sqrt(x * x + y * y + z * z);
+        x /= f2;
+        y /= f2;
+        z /= f2;
+        x += random.nextGaussian() * 0.0075D * (double)randomness;
+        y += random.nextGaussian() * 0.0075D * (double)randomness;
+        z += random.nextGaussian() * 0.0075D * (double)randomness;
+        x *= speed;
+        y *= speed;
+        z *= speed;
+        xd = x;
+        yd = y;
+        zd = z;
+        float hAng = MathHelper.sqrt(x * x + z * z);
+        yRotO = yRot = (float)((Math.atan2(x, z) * 180D) / Math.PI);
+        xRotO = xRot = (float)((Math.atan2(y, hAng) * 180D) / Math.PI);
     }
 
     @Override
 	public void lerpTo(double x, double y, double z, float yRot,
                        float xRot, int i)
     {
-        field_6387_m = x;
-        field_6386_n = y;
-        field_6385_o = z;
-        field_6384_p = yRot;
-        field_6383_q = xRot;
-        field_6388_l = i;
+        lerpX = x;
+        lerpY = y;
+        lerpZ = z;
+        lerpYRot = yRot;
+        lerpXRot = xRot;
+        lerpSteps = i;
         xd = velocityX;
         yd = velocityY;
         zd = velocityZ;
@@ -137,28 +135,28 @@ public class EntityBobber extends Entity
 	public void tick()
     {
         super.tick();
-        if(field_6388_l > 0)
+        if(lerpSteps > 0)
         {
-            double d = x + (field_6387_m - x) / (double)field_6388_l;
-            double d1 = y + (field_6386_n - y) / (double)field_6388_l;
-            double d2 = z + (field_6385_o - z) / (double)field_6388_l;
+            double d = x + (lerpX - x) / (double) lerpSteps;
+            double d1 = y + (lerpY - y) / (double) lerpSteps;
+            double d2 = z + (lerpZ - z) / (double) lerpSteps;
             double d4;
-            for(d4 = field_6384_p - (double) yRot; d4 < -180D; d4 += 360D) { }
+            for(d4 = lerpYRot - (double) yRot; d4 < -180D; d4 += 360D) { }
             for(; d4 >= 180D; d4 -= 360D) { }
-            yRot += d4 / (double)field_6388_l;
-            xRot += (field_6383_q - (double) xRot) / (double)field_6388_l;
-            field_6388_l--;
+            yRot += d4 / (double) lerpSteps;
+            xRot += (lerpXRot - (double) xRot) / (double) lerpSteps;
+            lerpSteps--;
             setPos(d, d1, d2);
             setRot(yRot, xRot);
             return;
         }
         if(!world.isClientSide)
         {
-            ItemStack heldPlayerItem = player.getCurrentEquippedItem();
-            if(player.removed || !player.isAlive() || heldPlayerItem == null || heldPlayerItem.getItem() != Item.toolFishingrod || distanceToSqr(player) > 1024D)
+            ItemStack heldPlayerItem = owner.getCurrentEquippedItem();
+            if(owner.removed || !owner.isAlive() || heldPlayerItem == null || heldPlayerItem.getItem() != Items.TOOL_FISHINGROD || distanceToSqr(owner) > 1024D)
             {
                 remove();
-                player.bobberEntity = null;
+                owner.bobberEntity = null;
                 return;
             }
             if(hookedEntity != null)
@@ -176,7 +174,7 @@ public class EntityBobber extends Entity
             }
         }
         if (inGround) {
-            if (world.getBlockId(xTile, yTile, zTile) == Block.rope.id) {
+            if (world.getBlockId(xTile, yTile, zTile) == Blocks.ROPE.id) {
                 x = xTile + 0.5D;
                 y = yTile + 0.5D;
                 z = zTile + 0.5D;
@@ -191,32 +189,32 @@ public class EntityBobber extends Entity
             }
         }
         ticksInAir++;
-        Vec3d currentPos = Vec3d.createVector(x, y, z);
-        Vec3d nextPos = Vec3d.createVector(x + xd, y + yd, z + zd);
-        HitResult hitResult = world.checkBlockCollisionBetweenPoints(currentPos, nextPos);
-        currentPos = Vec3d.createVector(x, y, z);
-        nextPos = Vec3d.createVector(x + xd, y + yd, z + zd);
-        if(hitResult != null)
+        Vec3 currentPos = Vec3.getTempVec3(x, y, z);
+        Vec3 nextPos = Vec3.getTempVec3(x + xd, y + yd, z + zd);
+        HitResult clip = world.checkBlockCollisionBetweenPoints(currentPos, nextPos);
+        currentPos = Vec3.getTempVec3(x, y, z);
+        nextPos = Vec3.getTempVec3(x + xd, y + yd, z + zd);
+        if(clip != null)
         {
-            nextPos = Vec3d.createVector(hitResult.location.xCoord, hitResult.location.yCoord, hitResult.location.zCoord);
-            if (hitResult.hitType == HitResult.HitType.TILE && world.getBlockId(hitResult.x, hitResult.y, hitResult.z) == Block.rope.id) {
+            nextPos = Vec3.getTempVec3(clip.location.x, clip.location.y, clip.location.z);
+            if (clip.hitType == HitResult.HitType.TILE && world.getBlockId(clip.x, clip.y, clip.z) == Blocks.ROPE.id) {
                 inGround = true;
-                xTile = hitResult.x;
-                yTile = hitResult.y;
-                zTile = hitResult.z;
+                xTile = clip.x;
+                yTile = clip.y;
+                zTile = clip.z;
             }
         }
         Entity entity = null;
-        List<Entity> list = world.getEntitiesWithinAABBExcludingEntity(this, bb.addCoord(xd, yd, zd).expand(1.0D, 1.0D, 1.0D));
+        List<Entity> list = world.getEntitiesWithinAABBExcludingEntity(this, bb.expand(xd, yd, zd).grow(1.0D, 1.0D, 1.0D));
         double d3 = 0.0D;
         for (Entity e : list)
         {
-            if (!e.isPickable() || e == player && ticksInAir < 5) {
+            if (!e.isPickable() || e == owner && ticksInAir < 5) {
                 continue;
             }
             float f2 = 0.3F;
-            AABB aabb = e.bb.expand(f2, f2, f2);
-            HitResult newHitResult = aabb.func_1169_a(currentPos, nextPos);
+            AABB aabb = e.bb.grow(f2, f2, f2);
+            HitResult newHitResult = aabb.clip(currentPos, nextPos);
             if (newHitResult == null) {
                 continue;
             }
@@ -229,20 +227,20 @@ public class EntityBobber extends Entity
 
         if(entity != null)
         {
-            hitResult = new HitResult(entity);
+            clip = new HitResult(entity);
         }
-        if(hitResult != null)
+        if(clip != null)
         {
-            if(hitResult.entity != null)
+            if(clip.entity != null)
             {
-                if(hitResult.entity.hurt(player, 0, DamageType.COMBAT))
+                if(clip.entity.hurt(owner, 0, DamageType.COMBAT))
                 {
-                    hookedEntity = hitResult.entity;
+                    hookedEntity = clip.entity;
                 }
             }
         }
         move(xd, yd, zd);
-        float f = MathHelper.sqrt_double(xd * xd + zd * zd);
+        float f = MathHelper.sqrt(xd * xd + zd * zd);
         yRot = (float)((java.lang.Math.atan2(xd, zd) * 180D) / Math.PI);
         for(xRot = (float)((java.lang.Math.atan2(yd, f) * 180D) / Math.PI); xRot - xRotO < -180F; xRotO -= 360F) { }
         for(; xRot - xRotO >= 180F; xRotO += 360F) { }
@@ -262,7 +260,7 @@ public class EntityBobber extends Entity
         {
             double d8 = ((bb.minY + ((bb.maxY - bb.minY) * (double)(l)) / (double)k) - 0.125D) + 0.125D;
             double d9 = ((bb.minY + ((bb.maxY - bb.minY) * (double)(l + 1)) / (double)k) - 0.125D) + 0.125D;
-            AABB axisalignedbb1 = AABB.getBoundingBoxFromPool(bb.minX, d8, bb.minZ, bb.maxX, d9, bb.maxZ);
+            AABB axisalignedbb1 = AABB.getTemporaryBB(bb.minX, d8, bb.minZ, bb.maxX, d9, bb.maxZ);
 
             if(world.isAABBInMaterial(axisalignedbb1, Material.water))
             {
@@ -280,12 +278,12 @@ public class EntityBobber extends Entity
                 int catchRate = 500;
                 int rainRate = 0;
                 int algaeRate = 0;
-                if(world.canBlockBeRainedOn(MathHelper.floor_double(x), MathHelper.floor_double(y) + 1, MathHelper.floor_double(z)))
+                if(world.canBlockBeRainedOn(MathHelper.floor(x), MathHelper.floor(y) + 1, MathHelper.floor(z)))
                 {
                     rainRate = 200;
                 }
 
-                if(world.getBlockId(MathHelper.floor_double(x), MathHelper.floor_double(y) + 1, MathHelper.floor_double(z)) == Block.algae.id) {
+                if(world.getBlockId(MathHelper.floor(x), MathHelper.floor(y) + 1, MathHelper.floor(z)) == Blocks.ALGAE.id) {
                     algaeRate = 100;
                 }
                 catchRate = (catchRate - rainRate) - algaeRate;
@@ -295,7 +293,7 @@ public class EntityBobber extends Entity
                     ticksCatchable = random.nextInt(30) + 10;
                     yd -= 0.2D;
                     world.playSoundAtEntity(null, this, "random.splash", 0.25F, 1.0F + (random.nextFloat() - random.nextFloat()) * 0.4F);
-                    float f3 = MathHelper.floor_double(bb.minY);
+                    float f3 = MathHelper.floor(bb.minY);
                     for(int i1 = 0; (float)i1 < 1.0F + bbWidth * 20F; i1++)
                     {
                         double xOff = (random.nextFloat() * 2.0F - 1.0F) * bbWidth;
@@ -331,13 +329,19 @@ public class EntityBobber extends Entity
     }
 
     @Override
-	public void addAdditionalSaveData(CompoundTag tag)
-    {
+	public void addAdditionalSaveData(CompoundTag compoundTag) {
+        compoundTag.putShort("xTile", (short)this.xTile);
+        compoundTag.putShort("yTile", (short)this.yTile);
+        compoundTag.putShort("zTile", (short)this.zTile);
+        compoundTag.putByte("inGround", (byte)(this.inGround ? 1 : 0));
     }
 
     @Override
-	public void readAdditionalSaveData(CompoundTag tag)
-    {
+	public void readAdditionalSaveData(CompoundTag compoundTag) {
+        this.xTile = compoundTag.getShort("xTile");
+        this.yTile = compoundTag.getShort("yTile");
+        this.zTile = compoundTag.getShort("zTile");
+        this.inGround = (compoundTag.getByte("inGround") == 1);
     }
 
     @Override
@@ -352,10 +356,10 @@ public class EntityBobber extends Entity
 
         if(inGround)
         {
-            double dx = x - player.x;
-            double dy = y - player.y;
-            double dz = z - player.z;
-            double distance = MathHelper.sqrt_double(dx * dx + dy * dy + dz * dz);
+            double dx = x - owner.x;
+            double dy = y - owner.y;
+            double dz = z - owner.z;
+            double distance = MathHelper.sqrt(dx * dx + dy * dy + dz * dz);
             dx /= distance;
             dy /= distance;
             dz /= distance;
@@ -364,36 +368,36 @@ public class EntityBobber extends Entity
             dy = MathHelper.clamp(dy, -clamp, clamp);
             dz = MathHelper.clamp(dz, -clamp, clamp);
             double scale = 2D;
-            player.xd += dx * scale;
-            player.yd += dy * scale;
-            player.zd += dz * scale;
+            owner.xd += dx * scale;
+            owner.yd += dy * scale;
+            owner.zd += dz * scale;
             damage = 5;
         }
         if(hookedEntity != null)
         {
-            double dx = player.x - x;
-            double dy = player.y - y;
-            double dz = player.z - z;
-            double distance = MathHelper.sqrt_double(dx * dx + dy * dy + dz * dz);
+            double dx = owner.x - x;
+            double dy = owner.y - y;
+            double dz = owner.z - z;
+            double distance = MathHelper.sqrt(dx * dx + dy * dy + dz * dz);
             double scale = 0.1D;
             hookedEntity.xd += dx * scale;
-            hookedEntity.yd += dy * scale + (double) MathHelper.sqrt_double(distance) * 0.08D;
+            hookedEntity.yd += dy * scale + (double) MathHelper.sqrt(distance) * 0.08D;
             hookedEntity.zd += dz * scale;
             damage = 3;
         }
         else if(ticksCatchable > 0)
         {
-            EntityItem entityitem = new EntityItem(world, x, y, z, new ItemStack(Item.foodFishRaw));
-            double dx = player.x - x;
-            double dy = player.y - y;
-            double dz = player.z - z;
-            double distance = MathHelper.sqrt_double(dx * dx + dy * dy + dz * dz);
+            ItemEntity entityitem = new ItemEntity(world, x, y, z, new ItemStack(Items.FOOD_FISH_RAW));
+            double dx = owner.x - x;
+            double dy = owner.y - y;
+            double dz = owner.z - z;
+            double distance = MathHelper.sqrt(dx * dx + dy * dy + dz * dz);
             double scale = 0.1D;
             entityitem.xd = dx * scale;
-            entityitem.yd = dy * scale + (double) MathHelper.sqrt_double(distance) * 0.08D;
+            entityitem.yd = dy * scale + (double) MathHelper.sqrt(distance) * 0.08D;
             entityitem.zd = dz * scale;
             world.entityJoinedWorld(entityitem);
-            player.addStat(StatList.fishCaughtStat, 1);
+            owner.addStat(StatList.fishCaughtStat, 1);
             damage = 1;
         }
         if(inGround)
@@ -401,7 +405,7 @@ public class EntityBobber extends Entity
             damage = 2;
         }
         remove();
-        player.bobberEntity = null;
+        owner.bobberEntity = null;
         return damage;
     }
 }
